package com.qgs.dc.s7.my.s7connector;

import com.qgs.dc.s7.my.s7connector.api.DaveArea;
import com.qgs.dc.s7.my.s7connector.api.S7Connector;
import com.qgs.dc.s7.my.s7connector.api.utils.ByteUtils;
import com.qgs.dc.s7.my.s7connector.enmuc.S7Client;
import com.qgs.dc.s7.my.s7connector.type.PlcVar;

import java.io.UnsupportedEncodingException;
import java.util.List;



/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2021/12/10 10:17
 */
public class MainForReadDemo {
    public static void main(String[] args) throws Exception {

//        //1200 部分
//        S7Connector connector1200 = S7Client.S7_1200.getConnector();
//
//        byte[] bool3_1200 = connector1200.read(DaveArea.DB, 1, 1, 0);
//        System.out.println("DB1-bool3_1200 : " + ByteUtils.toBoolean(bool3_1200));
////        byte[] bool4_1200 = connector1200.read(DaveArea.DB, 3, 1, 3267,5,PlcVar.BOOL.getTransportSize());
////        System.out.println("DB1-bool4_1200 : " + ByteUtils.toBoolean(bool4_1200));

        //1500 部分
        S7Connector connector1500 = S7Client.S7_1500.getConnector();
//        byte[] bool11 = connector1500.read(DaveArea.DB, 3, 1, 3267);
//        //30110012105301115
//        //[18, 17, 51, 48, 49, 49, 48, 48, 49, 50, 49, 48, 53, 51, 48, 49, 49, 49, 53, 0]
//        //          3   0
//        byte[] str1500 = connector1500.read(DaveArea.DB, 3, 20, 3270);
//        byte[] str15001 = connector1500.read(DaveArea.DB, 3, 20, 3290);
//        byte[] bool1 = connector1500.read(DaveArea.DB, 3, 1, 3267,4, PlcVar.BOOL.getTransportSize());
//        String str1500s = ByteUtils.toStr(str1500);
//        System.out.println("DB3.0-str1500 : " + str1500s);
//        System.out.println("DB3.0-bool1 : " + ByteUtils.toBoolean(bool1));



        //String
        //write
        String one = "12111";
        byte[] bytes1 = ByteUtils.strToBytes(one, 18);
        connector1500.write(DaveArea.DB,3,3270,bytes1);

        //read
        byte[] str_1500 = connector1500.read(DaveArea.DB, 3, 20, 3270);
        String string = ByteUtils.toStr(str_1500);
        System.out.println(string);


        //StringArray
        //write
        String[] src = new String[3];
        src[0]= "1";
        src[1]= "30110012105301117222";
        src[2]= "3";
        byte[] bytes = ByteUtils.strArrayToBytes(src, 18);
        connector1500.write(DaveArea.DB,3,3270,bytes);

        //read
        byte[] strList_1500 = connector1500.read(DaveArea.DB, 3, 60, 3270);
        String[] strings = ByteUtils.toStrArray(strList_1500, 3, 18);
        System.out.println(strings);

    }



}
