package com.qgs.dc.influx.template;

import lombok.Data;

import java.time.Instant;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/6/25 11:13
 */
@Data
public class Event {

    private Instant time;

    private String transationId;

    private String argName;

    private String argValue;

    //batchNumber（必填）， 作为区分 手动录入 和 自动录入的区别
    private String batchNum;

    private String inspectionSheetId;

    private String sampleNumber;

    public Event() {
        //自动录入，给个默认值
        this.batchNum = "-1";
        this.inspectionSheetId = "-1";
        this.sampleNumber = "-1";
    }


}
